﻿Option Strict On

Imports GestEntUsc_3apr09.AzioneSuForm
Imports MyPersonalClass
Imports MyPersonalClass.MieClassePersonaledll

Public Class Frm_Menu
    Private dt As New DataTable
    Private NrButnAndIntextB As List(Of String)
    Dim Qnorm As String = "SELECT id_Categorie, Categoria " & _
    "from tbl_Categorie order by tbl_Categorie.Categoria;"
    Dim QTrovEsat As String = "SELECT id_Categorie, Categoria from tbl_Categorie " & _
    "WHERE (((tbl_Categorie.Categoria)=?));"
    Dim QTrovPart As String = "SELECT id_Categorie, Categoria from tbl_Categorie " & _
    "WHERE (((tbl_Categorie.Categoria)LIKE ?)) order by tbl_Categorie.Categoria;"
    Dim QryElim As String = "DELETE tbl_Categorie.* " & _
    "FROM(tbl_Categorie) WHERE (((tbl_Categorie.id_Categorie)=?));"
    Dim QryUpdate As String = "UPDATE tbl_Categorie SET Categoria =? where id_Categorie =?;"
    Dim azFrm As New AzioneSuForm(Me, Qnorm, QTrovEsat, QTrovPart, QryElim, QryUpdate)
    Dim Aggiungi As Boolean = False

    Private Sub Frm_Menu_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Do
            Dim Ug As Boolean = VerificaPassword()
            If Ug = True Then Exit Do
        Loop


        Me.Visible = False
        DisableCloseButton(Me.Handle)
        Me.Text = "Menu"
    End Sub

    Private Sub CategorieToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CategorieToolStripMenuItem.Click

        Do
            Dim az As New AzioneSuForm(Me)
            Dim NrRit As Integer = az.AzioneRichiesta(sender)
            
            If NrRit = 6 Then
                Exit Do
                MyDataTable = New GestioneDatabase
            End If

        Loop

    End Sub

    Private InTesto As New List(Of String)

    Private Sub UsciteEntrateToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UsciteEntrateToolStripMenuItem.Click
        'ApriTab(sender)
    End Sub

    Private Sub SoggettiToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SoggettiToolStripMenuItem.Click
        'ApriTab(sender)
    End Sub
    Private Function VerificaPssw() As Integer

        Try


            Dim TBL As New MieClassePersonaledll
            Dim rcd As New Record
            dt = TBL.LanciaQuery(Me.Name, System.Reflection.MethodBase.GetCurrentMethod.Name, rcd, _
                            EnumQuery.SelectWithoutParameter, OleDbConnection1, OleDbDataAdapter1, _
                            connDB, "SELECT ID_PASSW, USERID, PASSWD FROM PASSW2")
            'sempre primo campo ID - ricordare

            If dt Is Nothing Then
                Return 0
            Else
                Return dt.Rows.Count
            End If

            dt.Clear()
            dt = Nothing


        Catch ex As Exception
            Dim cl As New MieClassePersonaledll
            cl.GestioneErrori(ex.Message, Err.Number)
        End Try
    End Function
    Private Function LanciaTabPssw(ByVal ArrLab As List(Of String), ByVal QuantiLoop As Integer, _
                                   Optional ByVal isPsw As Boolean = False) As List(Of String)


        'TextBox
        Dim ArrMyTxtBox As New List(Of MyControls)
        Dim Myc As New MyControls(New Point(121, 22), New Size(151, 20), , isPsw)
        ArrMyTxtBox.Add(Myc)
        Myc = New MyControls(New Point(121, 45), New Size(151, 20), , isPsw)
        ArrMyTxtBox.Add(Myc)

        'Label
        Dim ArrMyLabel As New List(Of MyControls)
        Myc = New MyControls(New Point(5, 25), New Size(95, 23), ArrLab(0 + (QuantiLoop * 2)))
        ArrMyLabel.Add(Myc)
        Myc = New MyControls(New Point(2, 48), New Size(113, 23), ArrLab(1 + (QuantiLoop * 2)))
        ArrMyLabel.Add(Myc)

        'Button
        Dim TextBut As New List(Of String)
        TextBut.Add("Azzera")
        TextBut.Add("Conferma")

        Dim ArrMyBttn As New List(Of MyControls)
        For i As Integer = 0 To 1
            Myc = New MyControls(New Point(41 + (i * 87), 99), New Size(85, 23), TextBut(i))
            ArrMyBttn.Add(Myc)
        Next


        Dim NumSubroutine As Integer = 0
        Dim ar As New ArrayControls(New Size(300, 176), "[ENTER] GIU`    [ESC]  SU`", ArrMyTxtBox, _
                                    ArrMyLabel, ArrMyBttn)
        ar.ShowDialog()
        Return ar.NumBttnAndInTextBox

    End Function

    Private Function VerificaPassword() As Boolean
        Dim Uguali As Boolean = False
        Dim myM As AllPurposeDialog.AllPurposeDialogBox

        'verifica se c'e` database se no ApriFile per ricerca
        Dim Rit As String = Dir(FileMDB, FileAttribute.Hidden)
        If Rit = vbNullString Then

            Dim cl As New MieClassePersonaledll
            Dim est As New ArrayList
            est.Add(MieClassePersonaledll.TipoEstensione.mdb)
            FileMDB = cl.CercaF(Microsoft.VisualBasic.FileIO.SpecialDirectories. _
                                      AllUsersApplicationData.Substring(0, 53), FileMDB, _
                                      est)
        End If

        'Verifico se la password e` gia` stata inserita e lancio Tabella Password
        Dim NrRec As Integer = VerificaPssw()
        Dim ContenutoTextBox As New List(Of String)

        If NrRec <> 0 Then 'se c'e` UerId & Passw prendo contenuto TextBox per verifica

            Do
                Dim InLab As New List(Of String)
                InLab.Add("UserId:")
                InLab.Add("Password:")
                ContenutoTextBox = LanciaTabPssw(InLab, 0, True)
                If CType(ContenutoTextBox(0), Integer) > 0 Then Exit Do
                'Se Button non e`: [Azzera] cioe` 0
            Loop

            'Decripto contenuto Psswd in Tabella
            IO.File.SetAttributes(FilNas, IO.FileAttributes.Hidden)
            Dim oRead As System.IO.StreamReader
            oRead = IO.File.OpenText(FilNas)
            Dim Chiav As String = oRead.ReadLine()
            oRead.Close()
            Dim PsswTab As String = AxCrypt1.Vernam.DecryptString( _
            CType(dt.Rows(0).Item(2), String), Chiav)

            If CType(dt.Rows(0).Item(1), String) = ContenutoTextBox(1) Then
                Uguali = True ' USERID = a campo tabella?
            Else
                Uguali = False
                MyMessgebox("UserId errata!", "Errore", True, True, 5)
            End If

            If Uguali = True Then
                If ContenutoTextBox(2) = PsswTab Then 'Pssw = a campo Tabella decriptato?
                    Uguali = True
                Else
                    OleDbConnection1.Close()
                    Uguali = False
                    MyMessgebox("Password errata!", "Errore", True, True, 5)
                End If

            End If

            Return Uguali


        Else 'se c'e` UserId & Passw li creo

            Dim DaInserire As New List(Of String)
            Do
                Dim Inlab As New List(Of String)
                Inlab.Add("UserId:")
                Inlab.Add("Conferma UserId:")
                Inlab.Add("Password:")
                Inlab.Add("Conferma Password:")
                For i As Integer = 0 To 1
                    'errore in contenutoTextbox - vedi LanciaTabPssw
                    If i = 0 Then ContenutoTextBox = LanciaTabPssw(Inlab, i) 'UserId & conferma
                    If i = 1 Then ContenutoTextBox = LanciaTabPssw(Inlab, i, True) 'Passw & conferma

                    If ContenutoTextBox(1) <> ContenutoTextBox(2) Then
                        Uguali = False 'non uguali ricomincio dall'inizio
                        MessageBox.Show("UserId e/o Passw errati", "Errore")
                        Exit For
                    Else
                        Uguali = True 'procedere
                        DaInserire.Add(ContenutoTextBox(1))
                    End If
                Next
                If Uguali Then Exit Do 'UserId & Passw uguali con relative conferme - procedi
            Loop

            Dim Chiav As String = AxCrypt1.Vernam.KeyGen(DaInserire(1)) 'creo chiave
            Dim PswCriptata As String = AxCrypt1.Vernam.EncryptString(DaInserire(1), Chiav)
            ' Password Cripata

            Dim oWrite As System.IO.StreamWriter
            oWrite = IO.File.CreateText(FilNas)
            oWrite.WriteLine(Chiav)
            IO.File.SetAttributes(FilNas, IO.FileAttributes.Hidden)
            oWrite.Close()

            '==== aggiungere record==== 
            Dim InsVal As New ArrayList, TpPrm As New List(Of Integer)
            Dim Rcd As New Record
            Dim Qry As String = "INSERT INTO Passw2 (Userid, Passwd) VALUES(?,?);"
            Dim dt As New System.Data.DataTable
            Dim Ins As Integer = EnumQuery.Insert

            InsVal.Add(DaInserire(0)) 'string
            TpPrm.Add(DbType.String)
            InsVal.Add(PswCriptata) 'string
            TpPrm.Add(DbType.String)

            Rcd = New Record(TpPrm, InsVal)

            Dim cl As New MieClassePersonaledll
            cl.LanciaQuery(Me.Name, System.Reflection.MethodBase.GetCurrentMethod.Name, _
                           Rcd, Ins, OleDbConnection1, OleDbDataAdapter1, connDB, Qry, _
                           "Record inserito con successo!")

            OleDbConnection1.Close()
            Return True

        End If
    End Function

    Public Sub New()

        ' Chiamata richiesta da Progettazione Windows Form.
        InitializeComponent()

        ' Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent().

    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub
End Class
